diff --git a/src/main/java/net/minecraft/client/render/block/color/BlockColorLeavesOak.java b/src/main/java/net/minecraft/client/render/block/color/BlockColorLeavesOak.java
index b002e3780..4191dae30 100644
--- a/src/main/java/net/minecraft/client/render/block/color/BlockColorLeavesOak.java
+++ b/src/main/java/net/minecraft/client/render/block/color/BlockColorLeavesOak.java
@@ -1,53 +1,42 @@
 package net.minecraft.client.render.block.color;
 
-import net.minecraft.client.render.colorizer.ColorProperties;
-import net.minecraft.client.render.colorizer.ColorizerFoliage;
-import net.minecraft.client.render.colorizer.LeavesColorProperties;
+import java.util.Random;
+
+import net.minecraft.client.render.colorizer.Colorizer;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.noise.ImprovedNoise;
 import net.minecraft.core.world.season.Season;
 import net.minecraft.core.world.season.Seasons;
 
-import java.util.Random;
-
-public class BlockColorLeavesOak
-    extends BlockColorLeaves
-{
-    private static ImprovedNoise fallColorPerlin = new ImprovedNoise(new Random(0));
-
-    public BlockColorLeavesOak()
-    {
-        super("oak");
-    }
-
-    @Override
-    public int getWorldColor(WorldSource world, int x, int y, int z)
-    {
-        LeavesColorProperties color = ColorProperties.getLeavesColor(colorId);
-        if (color == null) return 0xFFFFFF;
-        int foliageColor = ColorProperties.fRGB2iRGB(color.inventoryR, color.inventoryG, color.inventoryB);
-        if (world != null)
-        {
-            double temp = world.getBlockTemperature(x, z);
-            double hum = world.getBlockHumidity(x, z);
-            Season season = world.getSeasonManager().getCurrentSeason();
-            if (season != null)
-            {
-                float progress = world.getSeasonManager().getSeasonProgress();
-                foliageColor = ColorizerFoliage.getSeasonalColor(season, progress, temp, hum, color, true);
-                if (season == Seasons.OVERWORLD_FALL)
-                {
-                    float offsetIntensity = 1 - Math.abs((progress * 2) - 1);
-                    float green = ((foliageColor & 0x00FF00) >> 8) / 255F;
-                    float greenOffset = (float)fallColorPerlin.getValue(x / 10D, y / 10D, z / 10D) * offsetIntensity * 0.5f;
-                    if (green + greenOffset > 0.8f) greenOffset = 0.8f - green;
-                    if (green + greenOffset < 0.0f) greenOffset = -green;
-                    int newGreen = ((int)((green + greenOffset) * 255)) & 0xFF;
-                    foliageColor &= 0xFF00FF;
-                    foliageColor |= (newGreen << 8);
-                }
-            }
-        }
-        return foliageColor;
-    }
+public class BlockColorLeavesOak extends BlockColorCustom {
+	
+	private static ImprovedNoise fallColorPerlin = new ImprovedNoise(new Random(0));
+	
+	public BlockColorLeavesOak(Colorizer colorizer) {
+		super(colorizer);
+	}
+	
+	@Override
+	public int getWorldColor(WorldSource world, int x, int y, int z) {
+		int color = super.getWorldColor(world, x, y, z);
+		
+		Season season = world.getSeasonManager().getCurrentSeason();
+		if(season != null) {
+			float progress = world.getSeasonManager().getSeasonProgress();
+			if(season == Seasons.OVERWORLD_FALL) {
+				float offsetIntensity = 1 - Math.abs((progress * 2) - 1);
+				float green = ((color & 0x00FF00) >> 8) / 255F;
+				float greenOffset = (float) fallColorPerlin.getValue(x / 10D, y / 10D, z / 10D) * offsetIntensity * 0.5f;
+				if(green + greenOffset > 0.8f)
+					greenOffset = 0.8f - green;
+				if(green + greenOffset < 0.0f)
+					greenOffset = -green;
+				int newGreen = ((int) ((green + greenOffset) * 255)) & 0xFF;
+				color &= 0xFF00FF;
+				color |= (newGreen << 8);
+			}
+		}
+		
+		return color;
+	}
 }
diff --git a/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java b/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java
index fc4131b05..24e967e4b 100644
--- a/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java
+++ b/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java
@@ -1,34 +1,38 @@
 package net.minecraft.client.render.block.color;
 
-import net.minecraft.core.block.Block;
-import net.minecraft.client.render.colorizer.ColorizerGrass;
+import java.util.Random;
+
+import net.minecraft.client.render.colorizer.Colorizer;
+import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.core.world.WorldSource;
-import net.minecraft.core.world.biome.Biomes;
-import net.minecraft.core.world.season.Season;
-import net.minecraft.core.world.season.Seasons;
-
-public class BlockColorTallGrass
-    extends BlockColorGrass
-{
-    @Override
-    public int getWorldColor(WorldSource world, int x, int y, int z)
-    {
-
-        double localTemperature = world.getBlockTemperature(x, z);
-        double localHumidity = world.getBlockHumidity(x, z);
-
-        long l1 = x * 0x2fc20fL + z * 0x5d8875L + y;
-        l1 = l1 * l1 * 0x285b825L + l1 * 11L;
-        int xO = (int)((long) x + (l1 >> 14 & 31L));
-        int yO = (int)((long) y + (l1 >> 19 & 31L));
-        int zO = (int)((long) z + (l1 >> 24 & 31L));
-
-        float offsetT = (float) grassColorPerlin.getValue(xO / 32D, yO / 32D, z / 32D) / 2.5F;
-        float offsetH = (float) grassColorPerlin.getValue(x / 32D, yO / 32D, zO / 32D) / 2.5F;
-
-        localTemperature += offsetT;
-        localHumidity += offsetH;
-
-        return ColorizerGrass.defaultColor.getGrassColor(localTemperature, localHumidity);
-    }
+import net.minecraft.core.world.noise.ImprovedNoise;
+
+public class BlockColorTallGrass extends BlockColorCustom {
+	
+	protected static ImprovedNoise grassColorPerlin = new ImprovedNoise(new Random(0));
+	
+	public BlockColorTallGrass(Colorizer colorizer) {
+		super(colorizer);
+	}
+	
+	@Override
+	public int getWorldColor(WorldSource world, int x, int y, int z) {
+
+		double localTemperature = world.getBlockTemperature(x, z);
+		double localHumidity = world.getBlockHumidity(x, z);
+
+		long l1 = x * 0x2fc20fL + z * 0x5d8875L + y;
+		l1 = l1 * l1 * 0x285b825L + l1 * 11L;
+		int xO = (int) ((long) x + (l1 >> 14 & 31L));
+		int yO = (int) ((long) y + (l1 >> 19 & 31L));
+		int zO = (int) ((long) z + (l1 >> 24 & 31L));
+
+		float offsetT = (float) grassColorPerlin.getValue(xO / 32D, yO / 32D, z / 32D) / 2.5F;
+		float offsetH = (float) grassColorPerlin.getValue(x / 32D, yO / 32D, zO / 32D) / 2.5F;
+
+		localTemperature += offsetT;
+		localHumidity += offsetH;
+
+		return Colorizers.grass.getColor(localTemperature, localHumidity);
+	}
 }
diff --git a/src/main/java/net/minecraft/client/render/colorizer/ColorMap.java b/src/main/java/net/minecraft/client/render/colorizer/ColorMap.java
new file mode 100644
index 000000000..3d7ff8b35
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/colorizer/ColorMap.java
@@ -0,0 +1,29 @@
+package net.minecraft.client.render.colorizer;
+
+import net.minecraft.core.util.helper.MathHelper;
+
+public class ColorMap {
+	
+	public final Colorizer colorizer;
+	public final int[] buffer = new int[0x10000];
+	
+	public ColorMap(Colorizer colorizer) {
+		this.colorizer = colorizer;
+		
+		for(int i=0; i < buffer.length; i++) {
+			buffer[i] = 0xFFFFFFFF;
+		}
+	}
+	
+	public int getColor(double temp, double humid) {
+		temp = MathHelper.clamp(temp, 0.0, 1.0);
+		humid = MathHelper.clamp(humid, 0.0, 1.0);
+		
+		humid *= temp;	
+		
+		int x = (int) ((1.0 - temp) * 255.0);
+		int y = (int) ((1.0 - humid) * 255.0);
+		return buffer[y << 8 | x];
+	}
+
+}
diff --git a/src/main/java/net/minecraft/client/render/colorizer/Colorizer.java b/src/main/java/net/minecraft/client/render/colorizer/Colorizer.java
new file mode 100644
index 000000000..838a2588c
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/colorizer/Colorizer.java
@@ -0,0 +1,128 @@
+package net.minecraft.client.render.colorizer;
+
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.season.Season;
+import net.minecraft.core.world.season.Seasons;
+
+public class Colorizer {
+	
+	public final String name;
+	
+	private ColorMap defaultColor;
+	private Map<Season, ColorMap> seasonalColormaps;
+	private ColorMap currentColor;
+	private boolean enabled = false;
+	
+	public Colorizer(String name) {
+		this.name = name;
+	}
+	
+	public void setup(Minecraft minecraft, List<Season> seasons) {
+		this.defaultColor = new ColorMap(this);
+		this.seasonalColormaps = new HashMap<>();
+		this.currentColor = new ColorMap(this);
+		
+		if(Colorizers.loadColorData(defaultColor, "default")) {
+			this.enabled = true;
+			for(int i=0; i < seasons.size(); i++) {
+				Season season = seasons.get(i);
+				if(season == Seasons.NULL) {
+					continue;
+				}
+				
+				String seasonName = season.getId().replace('.', '_');
+				ColorMap colorMap = new ColorMap(this);
+				
+				if(Colorizers.loadColorData(colorMap, seasonName)) {
+					this.seasonalColormaps.put(season, colorMap);
+				}
+			}
+		}else {
+			this.enabled = false;
+		}
+	}
+	
+	public ColorMap getColormapForSeason(Season season) {
+		ColorMap colorMap = this.seasonalColormaps.get(season);
+		if(colorMap == null) {
+			return defaultColor;
+		}
+		return colorMap;
+	}
+	
+	public void update(Season season) {
+		ColorMap seasonColors = getColormapForSeason(season);
+		for(int i=0; i < currentColor.buffer.length; i++) {
+			currentColor.buffer[i] = seasonColors.buffer[i];
+		}
+	}
+	
+	public void update(Season season1, Season season2, float blendFactor) {
+		ColorMap seasonColors1 = getColormapForSeason(season1);
+		ColorMap seasonColors2 = getColormapForSeason(season2);
+		
+		for(int i=0; i < currentColor.buffer.length; i++) {
+			currentColor.buffer[i] = blendColor(seasonColors1.buffer[i], seasonColors2.buffer[i], blendFactor);
+		}
+	}
+	
+	public int getDefaultColor(double temperature, double humidity) {
+		if(!enabled) {
+			return 0xFFFFFFFF;
+		}
+		
+		return defaultColor.getColor(temperature, humidity);
+	}
+	
+	public int getColor(WorldSource world, int x, int y, int z) {
+		if(!enabled) {
+			return 0xFFFFFFFF;
+		}
+		
+		double temperature = world.getBlockTemperature(x, z);
+		double humidity = world.getBlockHumidity(x, z);
+		
+		return getColor(temperature, humidity);
+	}
+	
+	public int getColor(double temperature, double humidity) {
+		if(!enabled) {
+			return 0xFFFFFFFF;
+		}
+		
+		return currentColor.getColor(temperature, humidity);
+	}
+	
+	public boolean isEnabled() {
+		return enabled;
+	}
+	
+	public static int blendColor(int color1, int color2, float blend) {
+		float blend1 = 1.0f - blend;
+		
+		int r1 = (color1 >> 16) & 0xFF;
+		int g1 = (color1 >>  8) & 0xFF;
+		int b1 = (color1 >>  0) & 0xFF;
+		
+		int r2 = (color2 >> 16) & 0xFF;
+		int g2 = (color2 >>  8) & 0xFF;
+		int b2 = (color2 >>  0) & 0xFF;
+		
+		int r = (int)(r1 * blend1 + r2 * blend);
+		int g = (int)(g1 * blend1 + g2 * blend);
+		int b = (int)(b1 * blend1 + b2 * blend);
+		
+		r = MathHelper.clamp(r, 0, 255);
+		g = MathHelper.clamp(g, 0, 255);
+		b = MathHelper.clamp(b, 0, 255);
+		
+		return r << 16 | g << 8 | b; 
+	}
+
+}
diff --git a/src/main/java/net/minecraft/client/render/colorizer/Colorizers.java b/src/main/java/net/minecraft/client/render/colorizer/Colorizers.java
new file mode 100644
index 000000000..7ee772e51
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/colorizer/Colorizers.java
@@ -0,0 +1,212 @@
+package net.minecraft.client.render.colorizer;
+
+import java.awt.Graphics;
+import java.awt.image.BufferedImage;
+import java.io.InputStream;
+import java.util.ArrayList;
+import java.util.List;
+
+import javax.imageio.ImageIO;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.core.Global;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.season.Season;
+import net.minecraft.core.world.season.SeasonManagerCycle;
+import net.minecraft.core.world.season.Seasons;
+
+public class Colorizers {
+	
+	public static Minecraft mc;
+	
+	private static List<Colorizer> allColorizers = null;
+
+	public static Colorizer grass;
+	public static Colorizer water;
+	public static Colorizer sky;
+	public static Colorizer fog;
+	public static Colorizer oak;
+	public static Colorizer birch;
+	public static Colorizer pine;
+	public static Colorizer cherry;
+	public static Colorizer shrub;
+	public static Colorizer eucalyptus;
+	public static Colorizer cacao;
+	public static Colorizer thorn;
+	public static Colorizer palm;
+	
+	private static Season lastSeason;
+	private static float lastSeasonProgress;
+	
+	private static float fadeDuration = 1.0f;
+	
+	public static void init(Minecraft minecraft) {
+		mc = minecraft;
+		
+		registerColorizers();
+	}
+	
+	public static void reload() {
+		List<Season> seasons = Seasons.getAllSeasons();
+		
+		for(int i=0; i < allColorizers.size(); i++) {
+			allColorizers.get(i).setup(mc, seasons);
+		}
+		
+        update(true);
+	}
+	
+	public static void registerColorizers() {
+		allColorizers = new ArrayList<>();
+		
+		grass = add(new Colorizer("grass"));
+		water = add(new Colorizer("water"));
+		sky = add(new Colorizer("sky"));
+		fog = add(new Colorizer("fog"));
+		oak = add(new Colorizer("oak"));
+		birch = add(new Colorizer("birch"));
+		pine = add(new Colorizer("pine"));
+		cherry = add(new Colorizer("cherry"));
+		shrub = add(new Colorizer("shrub"));
+		eucalyptus = add(new Colorizer("eucalyptus"));
+		cacao = add(new Colorizer("cacao"));
+		thorn = add(new Colorizer("thorn"));
+		palm = add(new Colorizer("palm"));
+	}
+	
+	public static void update(boolean force) {
+		World world = mc.theWorld;
+		if(world == null) {
+			return;
+		}
+		
+		Season currentSeason = world.seasonManager.getCurrentSeason();
+		float seasonProgress = getSeasonProgress(world);
+		
+		boolean update;
+		if(force) {
+			update = true;
+		}else if(currentSeason != lastSeason) {
+			update = true;
+		}else if(seasonProgress != lastSeasonProgress) {
+			update = true;
+		}else {
+			update = false;
+		}
+		
+		if(!update) {
+			return;
+		}
+		
+		lastSeason = currentSeason;
+		lastSeasonProgress = seasonProgress;
+		
+		System.out.println("Updating Colorizers");
+		
+		Season season1, season2;
+		float blendFactor;
+		
+		float fadeDurationInverse = 1.0f - fadeDuration;
+		
+		if(seasonProgress < 0.5f) {
+			season1 = world.getSeasonManager().getPreviousSeason();
+			season2 = currentSeason;
+			blendFactor = seasonProgress + 0.5f; // 0.5 -> 1.0
+			if(fadeDuration == 0.0f) {
+				blendFactor = 1.0f;
+			}else {
+				blendFactor = seasonProgress * 2.0f; // 0.0 -> 1.0
+				blendFactor /= fadeDuration;
+				blendFactor = MathHelper.clamp(blendFactor, 0.0f, 1.0f); // 0.0 -> 1.0
+				blendFactor = blendFactor * 0.5f + 0.5f;
+			}
+		}else {
+			season1 = currentSeason;
+			season2 = world.getSeasonManager().getNextSeason();
+			blendFactor = seasonProgress - 0.5f; // 0.0 -> 0.5
+			if(fadeDuration == 0.0f) {
+				blendFactor = 0.0f;
+			}else if(fadeDuration != 1.0f) {
+				blendFactor = (seasonProgress - 0.5f) * 2.0f; //0.0 -> 1.0
+				blendFactor /= fadeDurationInverse;
+				blendFactor -= (1.0f / fadeDurationInverse) * fadeDuration;
+				blendFactor = MathHelper.clamp(blendFactor, 0.0f, 1.0f); // 0.0 -> 1.0
+			}
+		}
+		
+		for(int i=0; i < allColorizers.size(); i++) {
+			allColorizers.get(i).update(season1, season2, blendFactor);
+		}
+	}
+	
+	public static Colorizer add(Colorizer colorizer) {
+		allColorizers.add(colorizer);
+		return colorizer;
+	}
+	
+	public static boolean loadColorData(ColorMap colorMap, String name) {
+		String path = "/assets/minecraft/textures/colormap/" + colorMap.colorizer.name + "/" + name + ".png";
+		
+		InputStream in = null;
+		BufferedImage image = null;
+		
+		try {
+			in = mc.texturePackList.getResourceAsStream(path);
+			if(in == null) {
+				return false;
+			}
+			image = ImageIO.read(in);
+		}catch (Exception e) {
+			throw new RuntimeException("Loading colormap: '" + name + "'", e);
+		}finally {
+			try {
+				in.close();
+			}catch (Exception e) {}
+		}
+		
+		if(image.getWidth() == 1 && image.getHeight() == 1) {
+			int rgb = image.getRGB(0, 0);
+			
+			for(int i=0; i < colorMap.buffer.length; i++) {
+				colorMap.buffer[i] = rgb;
+			}
+			
+			return true;
+		}
+		
+		if(image.getWidth() != 256 || image.getHeight() != 256) {
+			BufferedImage fixedImage = new BufferedImage(256, 256, BufferedImage.TYPE_INT_RGB);
+			Graphics g = fixedImage.getGraphics();
+			g.drawImage(image, 0, 0, 256, 256, null);
+			g.dispose();
+			image = fixedImage;
+		}
+		
+		for(int x=0; x < 256; x++) {
+			for(int y=0; y < 256; y++) {
+				int rgb = image.getRGB(x, y);
+				
+				colorMap.buffer[y << 8 | x] = rgb;
+			}
+		}
+		
+		return true;
+	}
+	
+	public static float getSeasonProgress(World world) {
+		if(world.seasonManager instanceof SeasonManagerCycle) {
+			SeasonManagerCycle seasonManager = (SeasonManagerCycle) world.seasonManager;
+			Season currentSeason = seasonManager.getCurrentSeason();
+			
+			int dayInSeason = seasonManager.getDayInSeason();
+			int dayLengthTicks = Global.DAY_LENGTH_TICKS;
+			int seasonLengthDays = seasonManager.getSeasonLengthTicks(currentSeason) / dayLengthTicks;
+			
+			return dayInSeason / (float) seasonLengthDays;
+		}
+		
+		return 0.5f;
+	}
+
+}
diff --git a/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java b/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java
index b5c93cd47..38026b551 100644
--- a/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java
+++ b/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java
@@ -15,8 +15,10 @@ import net.minecraft.client.render.Renderer;
 import net.minecraft.client.render.Texture;
 import net.minecraft.core.Global;
 
-public class ShadersRenderer extends Renderer {
+public class ShadersRenderer implements Renderer {
 
+	public Minecraft mc;
+	
 	protected final Framebuffer worldFramebuffer = new Framebuffer();
 	protected final Texture worldFramebufferTex = new Texture();
 	protected final Texture worldFramebufferDepth = new Texture();
@@ -32,9 +34,12 @@ public class ShadersRenderer extends Renderer {
 	
 	public int fbWidth;
 	public int fbHeight;
+	
+	public int renderWidth;
+	public int renderHeight;
 
 	public ShadersRenderer(Minecraft minecraft) {
-		super(minecraft);
+		mc = minecraft;
 		
 		if(!Shaders.enableShaders) throw new RuntimeException("Shaders disabled!");
 	}
@@ -239,7 +244,18 @@ public class ShadersRenderer extends Renderer {
 			return internal;
 		}
 	}
+	
 	public Texture getWorldFramebufferTex(){
 		return worldFramebufferTex;
 	}
+	
+	@Override
+	public int getRenderWidth() {
+		return renderWidth;
+	}
+	
+	@Override
+	public int getRenderHeight() {
+		return renderHeight;
+	}
 }
diff --git a/src/main/java/net/minecraft/client/util/helper/ScreenshotHelper.java b/src/main/java/net/minecraft/client/util/helper/ScreenshotHelper.java
index d85e4f091..e3a18994c 100644
--- a/src/main/java/net/minecraft/client/util/helper/ScreenshotHelper.java
+++ b/src/main/java/net/minecraft/client/util/helper/ScreenshotHelper.java
@@ -11,6 +11,7 @@ import java.io.File;
 import javax.imageio.ImageIO;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.FallbackRenderer;
 import net.minecraft.client.render.Framebuffer;
 import net.minecraft.client.render.Renderer;
 import net.minecraft.client.render.Texture;
@@ -119,7 +120,7 @@ public class ScreenshotHelper {
 		fov = minecraft.gameSettings.FoV.value;
 		yaw = minecraft.thePlayer.yRot;
 		pitch = minecraft.thePlayer.xRot;
-		renderer = minecraft.render;
+		renderer = minecraft.renderer;
 		oldWidth = minecraft.resolution.width;
 		oldHeight = minecraft.resolution.height;
 		immersiveMode = minecraft.gameSettings.immersiveMode.value;
@@ -128,7 +129,7 @@ public class ScreenshotHelper {
 		minecraft.resolution.width = width;
 		minecraft.resolution.height = height;
 		
-		minecraft.render = new Renderer(minecraft);
+		minecraft.renderer = new FallbackRenderer(minecraft);
 	}
 	
 	public void delete() {
@@ -141,7 +142,7 @@ public class ScreenshotHelper {
 		minecraft.gameSettings.FoV.value = fov;
 		minecraft.thePlayer.yRot = yaw;
 		minecraft.thePlayer.xRot = pitch;
-		minecraft.render = renderer;
+		minecraft.renderer = renderer;
 		minecraft.resolution.width = oldWidth;
 		minecraft.resolution.height = oldHeight;
 		minecraft.gameSettings.immersiveMode.value = immersiveMode;
diff --git a/src/main/java/net/minecraft/client/world/WorldClient.java b/src/main/java/net/minecraft/client/world/WorldClient.java
index 78275056c..d79651dad 100644
--- a/src/main/java/net/minecraft/client/world/WorldClient.java
+++ b/src/main/java/net/minecraft/client/world/WorldClient.java
@@ -5,21 +5,18 @@ import java.util.LinkedList;
 import java.util.Set;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.core.world.Dimension;
-import net.minecraft.core.world.LevelListener;
-import net.minecraft.core.world.World;
-import net.minecraft.core.world.pathfinder.IdHashMap;
+import net.minecraft.client.net.handler.NetClientHandler;
+import net.minecraft.client.world.chunk.provider.ChunkProviderClient;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.client.net.handler.NetClientHandler;
 import net.minecraft.core.net.packet.Packet255KickDisconnect;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
-import net.minecraft.client.world.chunk.provider.ChunkProviderClient;
+import net.minecraft.core.world.pathfinder.IdHashMap;
 import net.minecraft.core.world.save.SaveHandlerClientMP;
 
-import static net.minecraft.core.Global.DAY_LENGTH_TICKS;
-
 // Referenced classes of package net.minecraft.src:
 //            World, SaveHandlerMP, WorldProvider, MCHash, 
 //            ChunkCoordinates, NetClientHandler, IWorldAccess, Entity, 
@@ -45,17 +42,6 @@ public class WorldClient extends World
     @Override
 	public void tick()
     {
-        setWorldTime(getWorldTime() + 1L);
-        int i = worldType.getSkyDarken(this, getWorldTime(), 1.0F);
-        if(i != skyDarken)
-        {
-            skyDarken = i;
-            for(int j = 0; j < listeners.size(); j++)
-            {
-                listeners.get(j).allChanged();
-            }
-
-        }
         for(int k = 0; k < 10 && !field_1053_F.isEmpty(); k++)
         {
             Entity entity = (Entity)field_1053_F.iterator().next();
@@ -76,15 +62,7 @@ public class WorldClient extends World
                 field_1057_z.remove(l--);
             }
         }
-
-        // Todo fix issue where frozen daycycle at exactly day spams the renderer reload, client doesn't have a way of knowing if the daycycle is disabled or not currently
-        if (getWorldTime() % DAY_LENGTH_TICKS == 0)
-        {
-            for (LevelListener listener : listeners)
-            {
-                listener.allChanged();
-            }
-        }
+		updateSeasonAndLight();
     }
 
     public void processPackets() {
diff --git a/src/main/java/net/minecraft/core/net/command/commands/TimeCommand.java b/src/main/java/net/minecraft/core/net/command/commands/TimeCommand.java
index 1c9b318f6..340e8deb7 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/TimeCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/TimeCommand.java
@@ -60,7 +60,7 @@ public class TimeCommand extends Command {
 
 			for (LevelListener listener : world.listeners)
 			{
-				listener.allChanged();
+				listener.allChanged(true, true);
 			}
 
 			return true;
@@ -73,7 +73,7 @@ public class TimeCommand extends Command {
 
 			for (LevelListener listener : world.listeners)
 			{
-				listener.allChanged();
+				listener.allChanged(true, true);
 			}
 
 			return true;
diff --git a/src/main/java/net/minecraft/core/world/LevelListener.java b/src/main/java/net/minecraft/core/world/LevelListener.java
index 6bb967ef3..0a509079a 100644
--- a/src/main/java/net/minecraft/core/world/LevelListener.java
+++ b/src/main/java/net/minecraft/core/world/LevelListener.java
@@ -36,7 +36,7 @@ public interface LevelListener
 
     void entityRemoved(Entity entity);
 
-    void allChanged();
+    void allChanged(boolean lightChanged, boolean seasonChanged);
 
     void playStreamingMusic(String soundPath, String Author, int x, int y, int z);
 
